diff --git a/source/simulation2/components/CCmpPathfinder.cpp b/source/simulation2/components/CCmpPathfinder.cpp
index 4ebdf08..9ea08e7 100644
--- a/source/simulation2/components/CCmpPathfinder.cpp
+++ b/source/simulation2/components/CCmpPathfinder.cpp
@@ -1,4 +1,4 @@
-/* Copyright (C) 2011 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -47,13 +47,19 @@ void CCmpPathfinder::Init(const CParamNode& UNUSED(paramNode))
 	m_MapSize = 0;
 	m_Grid = NULL;
 	m_ObstructionGrid = NULL;
+	m_ObstructionGridDirtyID = 0;
 	m_TerrainDirty = true;
 	m_NextAsyncTicket = 1;
 
 	m_DebugOverlay = NULL;
 	m_DebugGrid = NULL;
+	m_DebugGridJPS = NULL;
 	m_DebugPath = NULL;
 
+	PathfinderHierInit();
+
+//	SetDebugOverlay(true); // XXX
+
 	m_SameTurnMovesCount = 0;
 
 	// Since this is used as a system component (not loaded from an entity template),
@@ -152,6 +158,8 @@ void CCmpPathfinder::Deinit()
 	SetDebugOverlay(false); // cleans up memory
 	ResetDebugPath();
 
+	PathfinderHierDeinit();
+
 	delete m_Grid;
 	delete m_ObstructionGrid;
 }
@@ -235,6 +243,8 @@ void CCmpPathfinder::RenderSubmit(SceneCollector& collector)
 {
 	for (size_t i = 0; i < m_DebugOverlayShortPathLines.size(); ++i)
 		collector.Submit(&m_DebugOverlayShortPathLines[i]);
+
+	PathfinderHierRenderSubmit(collector);
 }
 
 
@@ -322,14 +332,16 @@ void CCmpPathfinder::UpdateGrid()
 	if (!m_Grid)
 	{
 		m_MapSize = cmpTerrain->GetTilesPerSide();
-		m_Grid = new Grid<TerrainTile>(m_MapSize, m_MapSize);
-		m_ObstructionGrid = new Grid<u8>(m_MapSize, m_MapSize);
+		m_Grid = new Grid<TerrainTile>(m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE, m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE);
+		m_ObstructionGrid = new Grid<u8>(m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE, m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE);
+		m_ObstructionGridDirtyID = 0;
 	}
 
 	CmpPtr<ICmpObstructionManager> cmpObstructionManager(GetSimContext(), SYSTEM_ENTITY);
 
-	bool obstructionsDirty = cmpObstructionManager->Rasterise(*m_ObstructionGrid);
+	bool obstructionsDirty = cmpObstructionManager->NeedUpdate(&m_ObstructionGridDirtyID);
 
+#if 0
 	if (obstructionsDirty && !m_TerrainDirty)
 	{
 		PROFILE("UpdateGrid obstructions");
@@ -343,11 +355,11 @@ void CCmpPathfinder::UpdateGrid()
 		// then TILE_OUTOFBOUNDS will change and we can't use this fast path, but
 		// currently it'll just set obstructionsDirty and we won't notice
 
-		for (u16 j = 0; j < m_MapSize; ++j)
+		for (u16 j = 0; j < m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE; ++j)
 		{
-			for (u16 i = 0; i < m_MapSize; ++i)
+			for (u16 i = 0; i < m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE; ++i)
 			{
-				TerrainTile& t = m_Grid->get(i, j);
+				TerrainTile& t = m_Grid->get(i/ICmpObstructionManager::NAVCELLS_PER_TILE, j/ICmpObstructionManager::NAVCELLS_PER_TILE);
 
 				u8 obstruct = m_ObstructionGrid->get(i, j);
 
@@ -365,7 +377,9 @@ void CCmpPathfinder::UpdateGrid()
 
 		++m_Grid->m_DirtyID;
 	}
-	else if (obstructionsDirty || m_TerrainDirty)
+	else
+#endif
+	if (obstructionsDirty || m_TerrainDirty)
 	{
 		PROFILE("UpdateGrid full");
 
@@ -479,17 +493,18 @@ void CCmpPathfinder::UpdateGrid()
 			}
 		}
 
-		// Apply passability classes to terrain
-		for (u16 j = 0; j < m_MapSize; ++j)
+		// Compute initial terrain-dependent passability
+		// TODO: expand by unit radius
+		for (u16 j = 0; j < m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE; ++j)
 		{
-			for (u16 i = 0; i < m_MapSize; ++i)
+			for (u16 i = 0; i < m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE; ++i)
 			{
 				fixed x, z;
-				TileCenter(i, j, x, z);
+				NavcellCenter(i, j, x, z);
 
 				TerrainTile t = 0;
 
-				u8 obstruct = m_ObstructionGrid->get(i, j);
+// 				u8 obstruct = m_ObstructionGrid->get(i, j);
 
 				fixed height = terrain.GetExactGroundLevelFixed(x, z);
 
@@ -499,23 +514,24 @@ void CCmpPathfinder::UpdateGrid()
 
 				fixed depth = water - height;
 
-				fixed slope = terrain.GetSlopeFixed(i, j);
-
-				fixed shoredist = fixed::FromInt(shoreGrid.get(i, j));
-
-				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING)
-					t |= 1;
-
-				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_FOUNDATION)
-					t |= 2;
-
-				if (obstruct & ICmpObstructionManager::TILE_OUTOFBOUNDS)
-				{
-					// If out of bounds, nobody is allowed to pass
-					for (size_t n = 0; n < m_PassClasses.size(); ++n)
-						t |= m_PassClasses[n].m_Mask;
-				}
-				else
+// 				fixed slope = terrain.GetExactSlopeFixed(x, z);
+				fixed slope = terrain.GetSlopeFixed(i / ICmpObstructionManager::NAVCELLS_PER_TILE, j / ICmpObstructionManager::NAVCELLS_PER_TILE);
+
+				fixed shoredist = fixed::FromInt(shoreGrid.get(i / ICmpObstructionManager::NAVCELLS_PER_TILE, j / ICmpObstructionManager::NAVCELLS_PER_TILE));
+
+// 				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING)
+// 					t |= 1;
+// 
+// 				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_FOUNDATION)
+// 					t |= 2;
+// 
+// 				if (obstruct & ICmpObstructionManager::TILE_OUTOFBOUNDS)
+// 				{
+// 					// If out of bounds, nobody is allowed to pass
+// 					for (size_t n = 0; n < m_PassClasses.size(); ++n)
+// 						t |= m_PassClasses[n].m_Mask;
+// 				}
+// 				else
 				{
 					for (size_t n = 0; n < m_PassClasses.size(); ++n)
 					{
@@ -524,7 +540,7 @@ void CCmpPathfinder::UpdateGrid()
 					}
 				}
 
-				std::string moveClass = terrain.GetMovementClass(i, j);
+				std::string moveClass = terrain.GetMovementClass(i / ICmpObstructionManager::NAVCELLS_PER_TILE, j / ICmpObstructionManager::NAVCELLS_PER_TILE);
 				if (m_TerrainCostClassTags.find(moveClass) != m_TerrainCostClassTags.end())
 					t |= COST_CLASS_MASK(m_TerrainCostClassTags[moveClass]);
 
@@ -532,9 +548,47 @@ void CCmpPathfinder::UpdateGrid()
 			}
 		}
 
+		for (size_t n = 0; n < m_PassClasses.size(); ++n)
+		{
+			if (m_PassClasses[n].m_HasClearance)
+				cmpObstructionManager->Rasterise(*m_Grid, m_PassClasses[n].m_Clearance, ICmpObstructionManager::FLAG_BLOCK_PATHFINDING, m_PassClasses[n].m_Mask);
+		}
+
+		if (1) // XXX: if circular
+		{
+			// WARNING: CCmpRangeManager::LosIsOffWorld needs to be kept in sync with this
+			const u16 edgeSize = 3 * ICmpObstructionManager::NAVCELLS_PER_TILE; // number of tiles around the edge that will be off-world
+
+			TerrainTile edgeMask = 0;
+			for (size_t n = 0; n < m_PassClasses.size(); ++n)
+				edgeMask |= m_PassClasses[n].m_Mask;
+
+			u16 w = m_Grid->m_W;
+			u16 h = m_Grid->m_H;
+			for (u16 j = 0; j < h; ++j)
+			{
+				for (u16 i = 0; i < w; ++i)
+				{
+					// Based on CCmpRangeManager::LosIsOffWorld
+					// but tweaked since it's tile-based instead.
+					// (We double all the values so we can handle half-tile coordinates.)
+					// This needs to be slightly tighter than the LOS circle,
+					// else units might get themselves lost in the SoD around the edge.
+
+					ssize_t dist2 = (i*2 + 1 - w)*(i*2 + 1 - w)
+						+ (j*2 + 1 - h)*(j*2 + 1 - h);
+
+					if (dist2 >= (w - 2*edgeSize) * (h - 2*edgeSize))
+						m_Grid->set(i, j, m_Grid->get(i, j) | edgeMask);
+				}
+			}
+		}
+
 		m_TerrainDirty = false;
 
 		++m_Grid->m_DirtyID;
+
+		PathfinderHierReload();
 	}
 }
 
diff --git a/source/simulation2/components/CCmpPathfinder_Common.h b/source/simulation2/components/CCmpPathfinder_Common.h
index f025ab9..964127f 100644
--- a/source/simulation2/components/CCmpPathfinder_Common.h
+++ b/source/simulation2/components/CCmpPathfinder_Common.h
@@ -34,12 +34,16 @@
 #include "graphics/Overlay.h"
 #include "graphics/Terrain.h"
 #include "maths/MathUtil.h"
+#include "simulation2/components/ICmpObstructionManager.h"
 #include "simulation2/helpers/Geometry.h"
 #include "simulation2/helpers/Grid.h"
 
 class PathfinderOverlay;
 class SceneCollector;
 struct PathfindTile;
+struct PathfindTileJPS;
+
+class CCmpPathfinder_Hier;
 
 #ifdef NDEBUG
 #define PATHFIND_DEBUG 0
@@ -107,6 +111,16 @@ public:
 		else
 			m_MaxShore = std::numeric_limits<fixed>::max();
 
+		if (node.GetChild("Clearance").IsOk())
+		{
+			m_HasClearance = true;
+			m_Clearance = node.GetChild("Clearance").ToFixed();
+		}
+		else
+		{
+			m_HasClearance = false;
+			m_Clearance = fixed::Zero();
+		}
 	}
 
 	bool IsPassable(fixed waterdepth, fixed steepness, fixed shoredist)
@@ -115,6 +129,10 @@ public:
 	}
 
 	ICmpPathfinder::pass_class_t m_Mask;
+
+	bool m_HasClearance; // whether static obstructions are impassable
+	fixed m_Clearance; // min distance from static obstructions
+
 private:
 	fixed m_MinDepth;
 	fixed m_MaxDepth;
@@ -137,6 +155,84 @@ const int COST_CLASS_BITS = 16 - (PASS_CLASS_BITS + 2);
 #define COST_CLASS_MASK(id) ( (TerrainTile) ((id) << (PASS_CLASS_BITS + 2)) )
 
 typedef SparseGrid<PathfindTile> PathfindTileGrid;
+typedef SparseGrid<PathfindTileJPS> PathfindTileJPSGrid;
+
+/**
+ * Represents the 2D coordinates of a tile.
+ * The i/j components are packed into a single u32, since we usually use these
+ * objects for comparisons and the VC2010 optimiser doesn't seem to automatically
+ * compare two u16s in a single operation.
+ */
+struct TileID
+{
+	TileID() { }
+
+	TileID(u16 i, u16 j) : data((i << 16) | j) { }
+
+	bool operator==(const TileID& b) const
+	{
+		return data == b.data;
+	}
+
+	/// Returns lexicographic order over (i,j)
+	bool operator<(const TileID& b) const
+	{
+		return data < b.data;
+	}
+
+	u16 i() const { return data >> 16; }
+	u16 j() const { return data & 0xFFFF; }
+
+private:
+	u32 data;
+};
+
+
+/**
+ * Represents the cost of a path consisting of horizontal/vertical and
+ * diagonal movements over a uniform-cost grid.
+ * Maximum path length before overflow is about 45K steps.
+ */
+struct PathCost
+{
+	PathCost() : data(0) { }
+
+	PathCost(u16 hv, u16 d) : data(hv*65536 + d*92682) { }
+
+	/// Construct for horizontal/vertical movement of given number of steps
+	static PathCost horizvert(u16 n)
+	{
+		return PathCost(n, 0);
+	}
+
+	/// Construct for diagonal movement of given number of steps
+	static PathCost diag(u16 n)
+	{
+		return PathCost(0, n);
+	}
+
+	PathCost operator+(const PathCost& a) const
+	{
+		PathCost c;
+		c.data = data + a.data;
+		return c;
+	}
+
+	bool operator<=(const PathCost& b) const { return data <= b.data; }
+	bool operator< (const PathCost& b) const { return data <  b.data; }
+	bool operator>=(const PathCost& b) const { return data >= b.data; }
+	bool operator> (const PathCost& b) const { return data >  b.data; }
+
+	u32 ToInt()
+	{
+		return data;
+	}
+
+private:
+	u32 data;
+};
+
+
 
 struct AsyncLongPathRequest
 {
@@ -201,8 +297,16 @@ public:
 	u16 m_MapSize; // tiles per side
 	Grid<TerrainTile>* m_Grid; // terrain/passability information
 	Grid<u8>* m_ObstructionGrid; // cached obstruction information (TODO: we shouldn't bother storing this, it's redundant with LSBs of m_Grid)
+	size_t m_ObstructionGridDirtyID;
 	bool m_TerrainDirty; // indicates if m_Grid has been updated since terrain changed
 	
+	CCmpPathfinder_Hier* m_PathfinderHier;
+	void PathfinderHierInit();
+	void PathfinderHierDeinit();
+	void PathfinderHierReload();
+	void PathfinderHierRenderSubmit(SceneCollector& collector);
+	bool PathfinderHierMakeGoalReachable(u16 i0, u16 j0, ICmpPathfinder::Goal& goal, pass_class_t passClass);
+
 	// For responsiveness we will process some moves in the same turn they were generated in
 	
 	u16 m_MaxSameTurnMoves; // max number of moves that can be created and processed in the same turn
@@ -210,7 +314,10 @@ public:
 	// Debugging - output from last pathfind operation:
 
 	PathfindTileGrid* m_DebugGrid;
+	PathfindTileJPSGrid* m_DebugGridJPS;
 	u32 m_DebugSteps;
+	double m_DebugTime;
+	Goal m_DebugGoal;
 	Path* m_DebugPath;
 	PathfinderOverlay* m_DebugOverlay;
 	pass_class_t m_DebugPassClass;
@@ -242,6 +349,8 @@ public:
 
 	virtual void ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& ret);
 
+	virtual void ComputePathJPS(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& ret);
+
 	virtual u32 ComputePathAsync(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, entity_id_t notify);
 
 	virtual void ComputeShortPath(const IObstructionTestFilter& filter, entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const Goal& goal, pass_class_t passClass, Path& ret);
@@ -254,6 +363,10 @@ public:
 
 	virtual void SetDebugOverlay(bool enabled);
 
+	virtual void GetDebugData(u32& steps, double& time, Grid<u8>& grid);
+
+	virtual void GetDebugDataJPS(u32& steps, double& time, Grid<u8>& grid);
+
 	virtual fixed GetMovementSpeed(entity_pos_t x0, entity_pos_t z0, cost_class_t costClass);
 
 	virtual CFixedVector2D GetNearestPointOnGoal(CFixedVector2D pos, const Goal& goal);
@@ -277,8 +390,14 @@ public:
 	 */
 	void NearestTile(entity_pos_t x, entity_pos_t z, u16& i, u16& j)
 	{
-		i = (u16)clamp((x / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), 0, m_MapSize-1);
-		j = (u16)clamp((z / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), 0, m_MapSize-1);
+		i = (u16)clamp((x / (int)TERRAIN_TILE_SIZE).ToInt_RoundToNegInfinity(), 0, m_MapSize-1);
+		j = (u16)clamp((z / (int)TERRAIN_TILE_SIZE).ToInt_RoundToNegInfinity(), 0, m_MapSize-1);
+	}
+
+	void NearestNavcell(entity_pos_t x, entity_pos_t z, u16& i, u16& j)
+	{
+		i = (u16)clamp((x / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToNegInfinity(), 0, m_MapSize*ICmpObstructionManager::NAVCELLS_PER_TILE - 1);
+		j = (u16)clamp((z / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToNegInfinity(), 0, m_MapSize*ICmpObstructionManager::NAVCELLS_PER_TILE - 1);
 	}
 
 	/**
@@ -290,6 +409,12 @@ public:
 		z = entity_pos_t::FromInt(j*(int)TERRAIN_TILE_SIZE + (int)TERRAIN_TILE_SIZE/2);
 	}
 
+	static void NavcellCenter(u16 i, u16 j, entity_pos_t& x, entity_pos_t& z)
+	{
+		x = entity_pos_t::FromInt(i*2 + 1).Multiply(ICmpObstructionManager::NAVCELL_SIZE / 2);
+		z = entity_pos_t::FromInt(j*2 + 1).Multiply(ICmpObstructionManager::NAVCELL_SIZE / 2);
+	}
+
 	static fixed DistanceToGoal(CFixedVector2D pos, const CCmpPathfinder::Goal& goal);
 
 	/**
diff --git a/source/simulation2/components/CCmpPathfinder_Hier.cpp b/source/simulation2/components/CCmpPathfinder_Hier.cpp
new file mode 100644
index 0000000..5f8c471
--- /dev/null
+++ b/source/simulation2/components/CCmpPathfinder_Hier.cpp
@@ -0,0 +1,600 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "precompiled.h"
+
+#include "CCmpPathfinder_Common.h"
+
+#include "renderer/Scene.h"
+#include "renderer/TerrainOverlay.h"
+#include "simulation2/helpers/Render.h"
+
+class PathfinderHierOverlay;
+
+class CCmpPathfinder_Hier
+{
+	typedef ICmpPathfinder::pass_class_t pass_class_t;
+
+	NONCOPYABLE(CCmpPathfinder_Hier);
+
+public:
+	struct RegionID
+	{
+		u8 ci, cj; // chunk ID
+		u16 r; // unique-per-chunk local region ID
+
+		RegionID(u8 ci, u8 cj, u16 r) : ci(ci), cj(cj), r(r) { }
+
+		bool operator<(RegionID b) const
+		{
+			if (ci < b.ci)
+				return true;
+			if (b.ci < ci)
+				return false;
+			if (cj < b.cj)
+				return true;
+			if (b.cj < cj)
+				return false;
+			return r < b.r;
+		}
+	};
+
+	CCmpPathfinder_Hier(CCmpPathfinder& pathfinder);
+	~CCmpPathfinder_Hier();
+
+	void Init(const std::vector<PathfinderPassability>& passClasses, Grid<TerrainTile>* grid);
+
+	RegionID Get(u16 i, u16 j, pass_class_t passClass);
+
+	bool MakeGoalReachable(u16 i0, u16 j0, ICmpPathfinder::Goal& goal, pass_class_t passClass);
+
+private:
+	static const u8 CHUNK_SIZE = 64; // number of navcells per side
+
+	class Chunk
+	{
+	public:
+		void InitRegions(u8 ci, u8 cj, Grid<TerrainTile>* grid, pass_class_t passClass);
+
+		RegionID Get(u16 i, u16 j);
+
+		void RegionCenter(u16 r, u16& i, u16& j) const;
+
+		bool RegionContainsGoal(u16 r, const PathGoal& goal) const;
+
+		void RegionNavcellNearest(u16 r, u16 iGoal, u16 jGoal, u16& iBest, u16& jBest, u32& dist2Best) const;
+
+	private:
+		void FloodFill(u8 i0, u8 j0, u16 r);
+
+		u8 m_ChunkI, m_ChunkJ; // chunk ID
+		u16 m_Regions[CHUNK_SIZE][CHUNK_SIZE]; // local region ID per navcell
+		u16 m_NumRegions; // number of local region IDs (starting from 1)
+	};
+
+	typedef std::map<RegionID, std::set<RegionID> > EdgesMap;
+
+	void FindEdges(u8 ci, u8 cj, pass_class_t passClass, EdgesMap& edges);
+
+	void AddDebugEdges(pass_class_t passClass);
+
+	void FindReachableRegions(RegionID from, std::set<RegionID>& reachable, pass_class_t passClass);
+
+	Chunk& GetChunk(u8 ci, u8 cj, pass_class_t passClass)
+	{
+		return m_Chunks[passClass].at(cj * m_ChunksW + ci);
+	}
+
+	CCmpPathfinder& m_Pathfinder;
+
+	PathfinderHierOverlay* m_DebugOverlay;
+
+	u16 m_ChunksW, m_ChunksH;
+	std::map<pass_class_t, std::vector<Chunk> > m_Chunks;
+	
+	std::map<pass_class_t, EdgesMap> m_Edges;
+
+public:
+	std::vector<SOverlayLine> m_DebugOverlayLines;
+};
+
+class PathfinderHierOverlay : public TerrainTextureOverlay
+{
+public:
+	CCmpPathfinder_Hier& m_PathfinderHier;
+
+	PathfinderHierOverlay(CCmpPathfinder_Hier& pathfinderHier) :
+		TerrainTextureOverlay(ICmpObstructionManager::NAVCELLS_PER_TILE), m_PathfinderHier(pathfinderHier)
+	{
+	}
+
+	virtual void BuildTextureRGBA(u8* data, size_t w, size_t h)
+	{
+		ICmpPathfinder::pass_class_t passClass = (ICmpPathfinder::pass_class_t)(1u << 4); // XXX
+
+		static u8 colors[][3] = {
+			{ 255, 0, 0 },
+			{ 0, 255, 0 },
+			{ 0, 0, 255 },
+			{ 255, 255, 0 },
+			{ 255, 0, 255 },
+			{ 0, 255, 255 },
+			{ 255, 255, 255 },
+
+			{ 127, 0, 0 },
+			{ 0, 127, 0 },
+			{ 0, 0, 127 },
+			{ 127, 127, 0 },
+			{ 127, 0, 127 },
+			{ 0, 127, 127 },
+			{ 127, 127, 127},
+
+			{ 255, 127, 0 },
+			{ 127, 255, 0 },
+			{ 255, 0, 127 },
+			{ 127, 0, 255},
+			{ 0, 255, 127 },
+			{ 0, 127, 255},
+			{ 255, 127, 127},
+			{ 127, 255, 127},
+			{ 127, 127, 255},
+
+			{ 127, 255, 255 },
+			{ 255, 127, 255 },
+			{ 255, 255, 127 },
+		};
+
+		for (size_t j = 0; j < h; ++j)
+		{
+			for (size_t i = 0; i < w; ++i)
+			{
+				SColor4ub color;
+
+				CCmpPathfinder_Hier::RegionID rid = m_PathfinderHier.Get(i, j, passClass);
+				if (rid.r == 0)
+					color = SColor4ub(0, 0, 0, 0);
+				else if (rid.r == 0xFFFF)
+					color = SColor4ub(255, 0, 255, 255);
+				else
+				{
+					int c = (rid.r + rid.ci*5 + rid.cj*7) % ARRAY_SIZE(colors);
+					color = SColor4ub(colors[c][0], colors[c][1], colors[c][2], 127);
+				}
+
+				*data++ = color.R;
+				*data++ = color.G;
+				*data++ = color.B;
+				*data++ = color.A;
+			}
+		}
+	}
+};
+
+void CCmpPathfinder_Hier::Chunk::InitRegions(u8 ci, u8 cj, Grid<TerrainTile>* grid, pass_class_t passClass)
+{
+	m_ChunkI = ci;
+	m_ChunkJ = cj;
+
+	memset(m_Regions, 0, sizeof(m_Regions));
+
+	u16 i0 = ci * CHUNK_SIZE;
+	u16 j0 = cj * CHUNK_SIZE;
+	u16 i1 = std::min((u16)(i0 + CHUNK_SIZE), grid->m_W);
+	u16 j1 = std::min((u16)(j0 + CHUNK_SIZE), grid->m_H);
+
+	// Start by filling the grid with 0 for blocked,
+	// and a 0xFFFF placeholder for unblocked
+	for (u16 j = j0; j < j1; ++j)
+	{
+		for (u16 i = i0; i < i1; ++i)
+		{
+			if (IS_PASSABLE(grid->get(i, j), passClass))
+				m_Regions[j - j0][i - i0] = 0xFFFF;
+			else
+				m_Regions[j - j0][i - i0] = 0;
+		}
+	}
+
+	// Scan for tiles with the 0xFFFF placeholder, and then floodfill
+	// the new region this tile belongs to
+	u16 r = 0;
+	for (u16 j = 0; j < CHUNK_SIZE; ++j)
+	{
+		for (u16 i = 0; i < CHUNK_SIZE; ++i)
+		{
+			if (m_Regions[j][i] == 0xFFFF)
+				FloodFill(i, j, ++r);
+		}
+	}
+
+	m_NumRegions = r;
+}
+
+void CCmpPathfinder_Hier::Chunk::FloodFill(u8 i0, u8 j0, u16 r)
+{
+	std::vector<std::pair<u8, u8> > stack;
+	stack.push_back(std::make_pair(i0, j0));
+
+	while (!stack.empty())
+	{
+		u8 i = stack.back().first;
+		u8 j = stack.back().second;
+		stack.pop_back();
+		m_Regions[j][i] = r;
+
+		if (i > 0 && m_Regions[j][i-1] == 0xFFFF)
+			stack.push_back(std::make_pair(i-1, j));
+		if (j > 0 && m_Regions[j-1][i] == 0xFFFF)
+			stack.push_back(std::make_pair(i, j-1));
+		if (i < CHUNK_SIZE-1 && m_Regions[j][i+1] == 0xFFFF)
+			stack.push_back(std::make_pair(i+1, j));
+		if (j < CHUNK_SIZE-1 && m_Regions[j+1][i] == 0xFFFF)
+			stack.push_back(std::make_pair(i, j+1));
+	}
+}
+
+
+CCmpPathfinder_Hier::RegionID CCmpPathfinder_Hier::Chunk::Get(u16 i, u16 j)
+{
+	return RegionID(m_ChunkI, m_ChunkJ, m_Regions[j % CHUNK_SIZE][i % CHUNK_SIZE]);
+}
+
+void CCmpPathfinder_Hier::Chunk::RegionCenter(u16 r, u16& i_out, u16& j_out) const
+{
+	u32 si = 0, sj = 0; // sum of i,j coords
+	u32 n = 0;
+
+	for (u16 j = 0; j < CHUNK_SIZE; ++j)
+	{
+		for (u16 i = 0; i < CHUNK_SIZE; ++i)
+		{
+			if (m_Regions[j][i] == r)
+			{
+				si += i;
+				sj += j;
+				n += 1;
+			}
+		}
+	}
+
+	// Avoid divide-by-zero
+	if (n == 0)
+		n = 1;
+
+	i_out = m_ChunkI * CHUNK_SIZE + si / n;
+	j_out = m_ChunkJ * CHUNK_SIZE + sj / n;
+}
+
+bool CCmpPathfinder_Hier::Chunk::RegionContainsGoal(u16 r, const PathGoal& goal) const
+{
+	for (u16 j = 0; j < CHUNK_SIZE; ++j)
+	{
+		for (u16 i = 0; i < CHUNK_SIZE; ++i)
+		{
+			if (m_Regions[j][i] == r)
+			{
+				if (goal.NavcellContainsGoal(m_ChunkI * CHUNK_SIZE + i, m_ChunkJ * CHUNK_SIZE + j))
+					return true;
+			}
+		}
+	}
+
+	return false;
+}
+
+void CCmpPathfinder_Hier::Chunk::RegionNavcellNearest(u16 r, u16 iGoal, u16 jGoal, u16& iBest, u16& jBest, u32& dist2Best) const
+{
+	iBest = 0;
+	jBest = 0;
+	dist2Best = std::numeric_limits<u32>::max();
+
+	for (u16 j = 0; j < CHUNK_SIZE; ++j)
+	{
+		for (u16 i = 0; i < CHUNK_SIZE; ++i)
+		{
+			if (m_Regions[j][i] == r)
+			{
+				u32 dist2 = ((i32)i + m_ChunkI*CHUNK_SIZE - iGoal)*((i32)i + m_ChunkI*CHUNK_SIZE - iGoal)
+				          + ((i32)j + m_ChunkJ*CHUNK_SIZE - jGoal)*((i32)j + m_ChunkJ*CHUNK_SIZE - jGoal);
+
+				if (dist2 < dist2Best)
+				{
+					iBest = i + m_ChunkI*CHUNK_SIZE;
+					jBest = j + m_ChunkJ*CHUNK_SIZE;
+					dist2Best = dist2;
+				}
+			}
+		}
+	}
+}
+
+CCmpPathfinder_Hier::CCmpPathfinder_Hier(CCmpPathfinder& pathfinder) :
+	m_Pathfinder(pathfinder)
+{
+	m_DebugOverlay = NULL;
+//	m_DebugOverlay = new PathfinderHierOverlay(*this);
+}
+
+CCmpPathfinder_Hier::~CCmpPathfinder_Hier()
+{
+	SAFE_DELETE(m_DebugOverlay);
+}
+
+void CCmpPathfinder_Hier::Init(const std::vector<PathfinderPassability>& passClasses, Grid<TerrainTile>* grid)
+{
+	m_ChunksW = (grid->m_W + CHUNK_SIZE - 1) / CHUNK_SIZE;
+	m_ChunksH = (grid->m_H + CHUNK_SIZE - 1) / CHUNK_SIZE;
+
+	m_Chunks.clear();
+	m_Edges.clear();
+
+	for (size_t n = 0; n < passClasses.size(); ++n)
+	{
+		pass_class_t passClass = passClasses[n].m_Mask;
+
+		// Compute the regions within each chunk
+		m_Chunks[passClass].resize(m_ChunksW*m_ChunksH);
+		for (u16 cj = 0; cj < m_ChunksH; ++cj)
+		{
+			for (u16 ci = 0; ci < m_ChunksW; ++ci)
+			{
+				m_Chunks[passClass].at(cj*m_ChunksW + ci).InitRegions(ci, cj, grid, passClass);
+			}
+		}
+
+		// Construct the search graph
+		
+		EdgesMap& edges = m_Edges[passClass];
+
+		for (u16 cj = 0; cj < m_ChunksH; ++cj)
+		{
+			for (u16 ci = 0; ci < m_ChunksW; ++ci)
+			{
+				FindEdges(ci, cj, passClass, edges);
+			}
+		}
+	}
+
+	m_DebugOverlayLines.clear();
+	AddDebugEdges((pass_class_t)(1u << 4));
+}
+
+void CCmpPathfinder_Hier::FindEdges(u8 ci, u8 cj, pass_class_t passClass, EdgesMap& edges)
+{
+	std::vector<Chunk>& chunks = m_Chunks[passClass];
+
+	Chunk& a = chunks.at(cj*m_ChunksW + ci);
+
+	if (ci > 0)
+	{
+		Chunk& b = chunks.at(cj*m_ChunksW + (ci-1));
+		for (u16 j = 0; j < CHUNK_SIZE; ++j)
+		{
+			RegionID ra = a.Get(0, j);
+			RegionID rb = b.Get(CHUNK_SIZE-1, j);
+			if (ra.r && rb.r)
+			{
+				edges[ra].insert(rb);
+				edges[rb].insert(ra);
+			}
+		}
+	}
+
+	if (cj > 0)
+	{
+		Chunk& b = chunks.at((cj-1)*m_ChunksW + ci);
+		for (u16 i = 0; i < CHUNK_SIZE; ++i)
+		{
+			RegionID ra = a.Get(i, 0);
+			RegionID rb = b.Get(i, CHUNK_SIZE-1);
+			if (ra.r && rb.r)
+			{
+				edges[ra].insert(rb);
+				edges[rb].insert(ra);
+			}
+		}
+	}
+
+}
+
+void CCmpPathfinder_Hier::AddDebugEdges(pass_class_t passClass)
+{
+	const EdgesMap& edges = m_Edges[passClass];
+	const std::vector<Chunk>& chunks = m_Chunks[passClass];
+
+	for (EdgesMap::const_iterator it = edges.begin(); it != edges.end(); ++it)
+	{
+		for (std::set<RegionID>::const_iterator rit = it->second.begin(); rit != it->second.end(); ++rit)
+		{
+			u16 i0, j0, i1, j1;
+			chunks[it->first.cj * m_ChunksW + it->first.ci].RegionCenter(it->first.r, i0, j0);
+			chunks[rit->cj * m_ChunksW + rit->ci].RegionCenter(rit->r, i1, j1);
+
+			CFixedVector2D a, b;
+			m_Pathfinder.NavcellCenter(i0, j0, a.X, a.Y);
+			m_Pathfinder.NavcellCenter(i1, j1, b.X, b.Y);
+
+			// Push inwards a little to avoid overlaps
+			CFixedVector2D d = b - a;
+			d.Normalize(entity_pos_t::FromInt(1));
+			a += d;
+			b -= d;
+
+			std::vector<float> xz;
+			xz.push_back(a.X.ToFloat());
+			xz.push_back(a.Y.ToFloat());
+			xz.push_back(b.X.ToFloat());
+			xz.push_back(b.Y.ToFloat());
+
+			m_DebugOverlayLines.push_back(SOverlayLine());
+			m_DebugOverlayLines.back().m_Color = CColor(1.0, 1.0, 1.0, 1.0);
+			SimRender::ConstructLineOnGround(m_Pathfinder.GetSimContext(), xz, m_DebugOverlayLines.back(), true);
+		}
+	}
+}
+
+CCmpPathfinder_Hier::RegionID CCmpPathfinder_Hier::Get(u16 i, u16 j, pass_class_t passClass)
+{
+	u16 ci = i / CHUNK_SIZE;
+	u16 cj = j / CHUNK_SIZE;
+	ENSURE(ci < m_ChunksW && cj < m_ChunksH);
+	return m_Chunks[passClass][cj*m_ChunksW + ci].Get(i, j);
+}
+
+bool CCmpPathfinder_Hier::MakeGoalReachable(u16 i0, u16 j0, ICmpPathfinder::Goal& goal, pass_class_t passClass)
+{
+	RegionID source = Get(i0, j0, passClass);
+
+	std::set<RegionID> reachableRegions;
+	FindReachableRegions(source, reachableRegions, passClass);
+
+// 	debug_printf(L"\nreach: ");
+// 	for (std::set<RegionID>::iterator it = reachableRegions.begin(); it != reachableRegions.end(); ++it)
+// 		debug_printf(L"[%d,%d,%d], ", it->ci, it->cj, it->r);
+// 	debug_printf(L"\n");
+
+	for (std::set<RegionID>::const_iterator it = reachableRegions.begin(); it != reachableRegions.end(); ++it)
+	{
+		// Skip region if its chunk doesn't contain the goal area
+		entity_pos_t x0 = ICmpObstructionManager::NAVCELL_SIZE * (it->ci * CHUNK_SIZE);
+		entity_pos_t z0 = ICmpObstructionManager::NAVCELL_SIZE * (it->cj * CHUNK_SIZE);
+		entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE * CHUNK_SIZE;
+		entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE * CHUNK_SIZE;
+		if (!goal.RectContainsGoal(x0, z0, x1, z1))
+			continue;
+
+		// If the region contains the goal area, the goal is reachable
+		// and we don't need to move it
+		if (GetChunk(it->ci, it->cj, passClass).RegionContainsGoal(it->r, goal))
+			return false;
+	}
+
+	// The goal area wasn't reachable
+
+	// Find the navcell that's nearest to the goal's center:
+	// * For each (reachable) region, record the (squared) minimal distance to the goal point
+	// * Sort regions by that underestimated distance
+	// * For each region, find the actual nearest navcell
+	// * Stop when the underestimated distances are worse than the best real distance
+
+	u16 iGoal, jGoal;
+	m_Pathfinder.NearestNavcell(goal.x, goal.z, iGoal, jGoal);
+
+	std::vector<std::pair<u32, RegionID> > regionDistEsts; // pair of (distance^2, region)
+
+	for (std::set<RegionID>::const_iterator it = reachableRegions.begin(); it != reachableRegions.end(); ++it)
+	{
+		u16 i0 = it->ci * CHUNK_SIZE;
+		u16 j0 = it->cj * CHUNK_SIZE;
+		u16 i1 = i0 + CHUNK_SIZE - 1;
+		u16 j1 = j0 + CHUNK_SIZE - 1;
+
+		// Pick the point in the chunk nearest the goal
+		u16 iNear = Clamp(iGoal, i0, i1);
+		u16 jNear = Clamp(jGoal, j0, j1);
+
+		u32 dist2 = ((i32)iNear - iGoal)*((i32)iNear - iGoal)
+		          + ((i32)jNear - jGoal)*((i32)jNear - jGoal);
+
+		regionDistEsts.push_back(std::make_pair(dist2, *it));
+	}
+
+	// Sort by increasing distance (tie-break on RegionID)
+	std::sort(regionDistEsts.begin(), regionDistEsts.end());
+
+	u16 iBest = i0;
+	u16 jBest = j0;
+	u32 dist2Best = std::numeric_limits<u32>::max();
+
+	for (size_t n = 0; n < regionDistEsts.size(); ++n)
+	{
+		RegionID region = regionDistEsts[n].second;
+
+		debug_printf(L"# region [%d,%d,%d] est %d\n", region.ci, region.cj, region.r, regionDistEsts[n].first);
+
+		if (regionDistEsts[n].first >= dist2Best)
+			break;
+
+		u16 i, j;
+		u32 dist2;
+		GetChunk(region.ci, region.cj, passClass).RegionNavcellNearest(region.r, iGoal, jGoal, i, j, dist2);
+
+		debug_printf(L"#   actual dist [%d,%d] = %d\n", i, j, dist2);
+
+		if (dist2 < dist2Best)
+		{
+			iBest = i;
+			jBest = j;
+			dist2Best = dist2;
+		}
+	}
+
+	PathGoal newGoal;
+	newGoal.type = PathGoal::POINT;
+	m_Pathfinder.NavcellCenter(iBest, jBest, newGoal.x, newGoal.z);
+	goal = newGoal;
+
+	return true;
+}
+
+void CCmpPathfinder_Hier::FindReachableRegions(RegionID from, std::set<RegionID>& reachable, pass_class_t passClass)
+{
+	std::vector<RegionID> open;
+	open.push_back(from);
+	reachable.insert(from);
+
+	while (!open.empty())
+	{
+		RegionID curr = open.back();
+		open.pop_back();
+
+		const std::set<RegionID>& neighbours = m_Edges[passClass][curr];
+		for (std::set<RegionID>::const_iterator it = neighbours.begin(); it != neighbours.end(); ++it)
+		{
+			// Add to the reachable set; if this is the first time we added
+			// then also add it to the open set
+			if (reachable.insert(*it).second)
+				open.push_back(*it);
+		}
+	}
+}
+
+void CCmpPathfinder::PathfinderHierInit()
+{
+	m_PathfinderHier = new CCmpPathfinder_Hier(*this);
+}
+
+void CCmpPathfinder::PathfinderHierDeinit()
+{
+	SAFE_DELETE(m_PathfinderHier);
+}
+
+void CCmpPathfinder::PathfinderHierReload()
+{
+	m_PathfinderHier->Init(m_PassClasses, m_Grid);
+}
+
+void CCmpPathfinder::PathfinderHierRenderSubmit(SceneCollector& collector)
+{
+	for (size_t i = 0; i < m_PathfinderHier->m_DebugOverlayLines.size(); ++i)
+		collector.Submit(&m_PathfinderHier->m_DebugOverlayLines[i]);
+}
+
+bool CCmpPathfinder::PathfinderHierMakeGoalReachable(u16 i0, u16 j0, ICmpPathfinder::Goal& goal, pass_class_t passClass)
+{
+	return m_PathfinderHier->MakeGoalReachable(i0, j0, goal, passClass);
+}
\ No newline at end of file
